/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : March, 1997                                                    */
/* File Name : sigmoidMF.cc                                              */
/*************************************************************************/
/*************************************************************************/

#include "sigmoidMF.h"
#include "XsigmoidMF.h"
#include "Function.h"
#include "../deffunc.h"
#include <iostream.h>
#include <math.h>

sigmoidMF::sigmoidMF(float _l, float _IT)
{  
    center = _l;
    spread = _IT;
    cutOff = 1.0;

}// end of constructor

sigmoidMF::setCenter(float _newValue) 
{ center = _newValue; 
  return 1;
}// end of setLeftBorder()

sigmoidMF::setSpread(float _newValue) 
{ spread = _newValue; 
  return 1;
}// end of setLeftTop()

float sigmoidMF::getCenter() const { return center; }

float sigmoidMF::getSpread() const { return spread; }

float sigmoidMF::getValue(float x) 
{ float ret; 
  ret= 1.0/(1.0+exp(-1.0*spread*(x-center)));
  return minimum(ret,cutOff);
}// end of getValue()

Function *sigmoidMF::Xversion()
{  XsigmoidMF *ret = new XsigmoidMF(center,spread);
   (*ret).setCutOff(cutOff);
   return ret;
}// end of Xversion()

Function *sigmoidMF::getMyTwin()
{  sigmoidMF *ret = new sigmoidMF(center,spread);
   (*ret).setCutOff(cutOff);
   return ret;
}// end of getMyTwin()

ostream& operator<<(ostream& os, const sigmoidMF& RHS)
{  os << " Sigmoid("<<RHS.center<<","<<RHS.spread << ") with " <<RHS.cutOff;
   return os;
}// end of operator<<

void sigmoidMF::printOn(ostream& os) const {  os<<(*this); }


